Index: /branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/DataGridContentView.cs
===================================================================
--- /branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/DataGridContentView.cs	(revision 14582)
+++ /branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/DataGridContentView.cs	(revision 14583)
@@ -70,11 +70,4 @@
       List<KeyValuePair<int, SortOrder>> order = new List<KeyValuePair<int, SortOrder>>(base.sortedColumnIndices);
       base.OnContentChanged();
-
-      foreach (DataGridViewColumn column in DataGridView.Columns) {
-        var variable = column.HeaderText;
-        bool isInputTarget = Content.PreProcessingData.InputVariables.Contains(variable)
-          || Content.PreProcessingData.TargetVariable == variable;
-        column.Visible = isInputTarget;
-      }
 
       DataGridView.RowHeadersWidth = 70;
Index: /branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/HistogramView.Designer.cs
===================================================================
--- /branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/HistogramView.Designer.cs	(revision 14582)
+++ /branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/HistogramView.Designer.cs	(revision 14583)
@@ -46,5 +46,7 @@
     private void InitializeComponent() {
       this.optionsBox = new System.Windows.Forms.GroupBox();
+      this.label2 = new System.Windows.Forms.Label();
       this.label1 = new System.Windows.Forms.Label();
+      this.aggregationComboBox = new System.Windows.Forms.ComboBox();
       this.classifierComboBox = new System.Windows.Forms.ComboBox();
       ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).BeginInit();
@@ -63,13 +65,24 @@
       // optionsBox
       // 
+      this.optionsBox.Controls.Add(this.label2);
       this.optionsBox.Controls.Add(this.label1);
+      this.optionsBox.Controls.Add(this.aggregationComboBox);
       this.optionsBox.Controls.Add(this.classifierComboBox);
       this.optionsBox.Dock = System.Windows.Forms.DockStyle.Bottom;
-      this.optionsBox.Location = new System.Drawing.Point(0, 334);
+      this.optionsBox.Location = new System.Drawing.Point(0, 292);
       this.optionsBox.Name = "optionsBox";
-      this.optionsBox.Size = new System.Drawing.Size(180, 69);
+      this.optionsBox.Size = new System.Drawing.Size(180, 111);
       this.optionsBox.TabIndex = 7;
       this.optionsBox.TabStop = false;
-      this.optionsBox.Text = "Options";
+      this.optionsBox.Text = "Grouping Options";
+      // 
+      // label2
+      // 
+      this.label2.AutoSize = true;
+      this.label2.Location = new System.Drawing.Point(2, 61);
+      this.label2.Name = "label2";
+      this.label2.Size = new System.Drawing.Size(67, 13);
+      this.label2.TabIndex = 2;
+      this.label2.Text = "Aggregation:";
       // 
       // label1
@@ -78,7 +91,19 @@
       this.label1.Location = new System.Drawing.Point(3, 15);
       this.label1.Name = "label1";
-      this.label1.Size = new System.Drawing.Size(81, 13);
+      this.label1.Size = new System.Drawing.Size(48, 13);
       this.label1.TabIndex = 2;
-      this.label1.Text = "Target variable:";
+      this.label1.Text = "Variable:";
+      // 
+      // aggregationComboBox
+      // 
+      this.aggregationComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.aggregationComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
+      this.aggregationComboBox.FormattingEnabled = true;
+      this.aggregationComboBox.Location = new System.Drawing.Point(5, 79);
+      this.aggregationComboBox.Name = "aggregationComboBox";
+      this.aggregationComboBox.Size = new System.Drawing.Size(169, 21);
+      this.aggregationComboBox.TabIndex = 1;
+      this.aggregationComboBox.SelectedIndexChanged += new System.EventHandler(this.aggregationComboBox_SelectedIndexChanged);
       // 
       // classifierComboBox
@@ -88,5 +113,5 @@
       this.classifierComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
       this.classifierComboBox.FormattingEnabled = true;
-      this.classifierComboBox.Location = new System.Drawing.Point(5, 32);
+      this.classifierComboBox.Location = new System.Drawing.Point(5, 33);
       this.classifierComboBox.Name = "classifierComboBox";
       this.classifierComboBox.Size = new System.Drawing.Size(169, 21);
@@ -114,5 +139,6 @@
     private System.Windows.Forms.ComboBox classifierComboBox;
     private System.Windows.Forms.Label label1;
-
+    private System.Windows.Forms.Label label2;
+    private System.Windows.Forms.ComboBox aggregationComboBox;
   }
 }
Index: /branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/HistogramView.cs
===================================================================
--- /branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/HistogramView.cs	(revision 14582)
+++ /branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/HistogramView.cs	(revision 14583)
@@ -36,4 +36,6 @@
     public HistogramView() {
       InitializeComponent();
+      aggregationComboBox.DataSource = Enum.GetValues(typeof(DataRowVisualProperties.DataRowHistogramAggregation));
+      aggregationComboBox.SelectedItem = DataRowVisualProperties.DataRowHistogramAggregation.Overlapping;
     }
 
@@ -82,4 +84,5 @@
         classRow.Name = group.Key;
         classRow.VisualProperties.ChartType = DataRowVisualProperties.DataRowChartType.Histogram;
+        classRow.VisualProperties.Aggregation = (DataRowVisualProperties.DataRowHistogramAggregation)aggregationComboBox.SelectedItem;
         classRow.Values.AddRange(group);
         dataTable.Rows.Add(classRow);
@@ -96,4 +99,12 @@
       GenerateLayout();
     }
+
+    private void aggregationComboBox_SelectedIndexChanged(object sender, EventArgs e) {
+      foreach (var dt in dataTables.Values) {
+        foreach (var row in dt.Rows) {
+          row.VisualProperties.Aggregation = (DataRowVisualProperties.DataRowHistogramAggregation)aggregationComboBox.SelectedItem;
+        }
+      }
+    }
   }
 }